<TeXmacs|2.1.2>

<style|<tuple|beamer|vdh|wide-spacing|shadowed-frames|shadowed-titles|std-frame|old-lengths|biolinum-font|reddish|framed-theorems|caas>>

<\body>
  <\hide-preamble>
    <assign|xfont|mathlarge=TeX Gyre Pagella,Fira>

    <assign|title-sub-bar-contents|<macro|body|>>

    \;

    <assign|rsC|<macro|<with|font|cal*|C>>>

    <assign|rsT|<macro|<with|font|cal*|T>>>

    <assign|marked|<macro|body|<tabular*|<tformat|<cwith|1|1|1|1|cell-background|dark
    grey>|<cwith|1|1|1|1|cell-bsep|0.25spc>|<cwith|1|1|1|1|cell-tsep|0.25spc>|<cwith|1|1|1|1|cell-lsep|1spc>|<cwith|1|1|1|1|cell-rsep|1spc>|<table|<row|<cell|<arg|body>>>>>>>>

    \;

    <assign|compressed|<\macro|body>
      <\surround||<right-flush>>
        <\with|par-par-sep|<times|0.4|<value|par-par-sep>>>
          <arg|body>
        </with>
      </surround>
    </macro>>

    \;

    <assign|alt-theme|<macro|body|<with|vador-title-bg-color|#37441d|ornament-shadow-color|#37441d|ornament-sunny-color|dark
    yellow|deco-shadow-effect|<eff-recolor|0|dark yellow>|<arg|body>>>>

    <assign|strong|<macro|x|<with|color|<value|strong-color>|math-color|<value|strong-color>|<uncolored-strong|<arg|x>>>>>

    \;

    <assign|striped-table|<macro|body|<tformat|<cwith|1|-1|1|-1|cell-background|<if|<equal|<mod|<value|cell-row-nr>|2>|0>|#101050|>>|<twith|table-width|1par>|<twith|table-hmode|exact>|<arg|body>>>>
  </hide-preamble>

  <screens|<shown|<\with-screen-color|<pattern|vertical-white-black.png|100%|100%|<eff-gradient|0|white|#8098b0>>>
    <\with|par-left|-5mm|par-right|-5mm>
      <assign|page-this-top|0mm><image|issac22-header.jpg|1par|||>
    </with>

    <\with|par-mode|center>
      <tabular*|<tformat|<cwith|1|2|1|1|cell-bsep|2.5spc>|<cwith|1|1|1|1|cell-bsep|2spc>|<cwith|1|1|1|1|cell-tsep|4spc>|<cwith|2|2|1|1|cell-tsep|4spc>|<table|<row|<cell|<huge|<strong|<with|color|dark
      red|On the complexity of symbolic computation>>>>>|<row|<cell|<tabular*|<tformat|<twith|table-valign|T>|<cwith|1|1|1|1|cell-bsep|1spc>|<cwith|1|1|1|1|cell-tsep|1spc>|<table|<row|<cell|>>>>>
      <very-large|<tabular*|<tformat|<twith|table-valign|T>|<table|<row|<cell|<strong|Joris
      van der Hoeven> >>|<row|<cell|<normal-size|CNRS, cole
      polytechnique>>>>>>>>>|<row|<cell|<strong|June 1, 2022>>>>>>
    </with>

    \;
  </with-screen-color>>|<\hidden>
    <large|<strong|How fast can problems in symbolic computation be
    solved?><vspace|0.5fn>>

    \;

    <\overlays-phantoms|1|7>
      <\wide-tabular>
        <tformat|<cwith|1|-1|3|4|cell-hpart|1>|<cwith|1|-1|2|2|cell-halign|c>|<cwith|6|6|4|4|cell-bsep|2spc>|<cwith|6|6|4|4|cell-tsep|2spc>|<cwith|3|3|1|1|cell-halign|r>|<table|<row|<\cell>
          \;
        </cell>|<\cell>
          \;
        </cell>|<\cell>
          <overlay-from|3|Complexity of particular algorithm|>
        </cell>|<\cell>
          \;
        </cell>>|<row|<\cell>
          \;
        </cell>|<\cell>
          <overlay-from|3|<math|\<nearrow\>>|>
        </cell>|<\cell>
          \;
        </cell>|<\cell>
          \;
        </cell>>|<row|<\cell>
          <overlay-from|2|<strong|Analysis of algorithms>|>
        </cell>|<\cell>
          <overlay-from|4|<math|\<rightarrow\>>|>
        </cell>|<\cell>
          <overlay-from|4|Mathematical tools for analysis|>
        </cell>|<\cell>
          \;
        </cell>>|<row|<\cell>
          \;
        </cell>|<\cell>
          <overlay-from|4|<math|\<searrow\>>|>
        </cell>|<\cell>
          \;
        </cell>|<\cell>
          \;
        </cell>>|<row|<\cell>
          \;
        </cell>|<\cell>
          \;
        </cell>|<\cell>
          <overlay-from|4|Insight for improved design|>
        </cell>|<\cell>
          \;
        </cell>>|<row|<\cell>
          \;
        </cell>|<\cell>
          \;
        </cell>|<\cell>
          \;
        </cell>|<\cell>
          <overlay-from|7|<tabular*|<tformat|<cwith|1|-1|1|1|cell-lsep|0spc>|<cwith|1|-1|1|1|cell-rsep|0spc>|<cwith|1|1|1|1|cell-tsep|0spc>|<cwith|2|2|1|1|cell-bsep|0spc>|<table|<row|<cell|<with|condensed-factor|0.95|<condensed|Model
          behavior of>>>>|<row|<cell|implementations>>>>>|>
        </cell>>|<row|<\cell>
          \;
        </cell>|<\cell>
          \;
        </cell>|<\cell>
          <overlay-from|5|Relations between <math|\<gtr\>1> problems|>
        </cell>|<\cell>
          \;
        </cell>>|<row|<\cell>
          \;
        </cell>|<\cell>
          <overlay-from|5|<math|\<nearrow\>>|>
        </cell>|<\cell>
          \;
        </cell>|<\cell>
          \;
        </cell>>|<row|<\cell>
          <overlay-from|2|<strong|<with|condensed-factor|0.95|<condensed|Computational
          complexity>>>|>
        </cell>|<\cell>
          <math|<overlay-from|6|\<rightarrow\>|>>
        </cell>|<\cell>
          <overlay-from|6|Complexity classes|>
        </cell>|<\cell>
          \;
        </cell>>|<row|<\cell>
          \;
        </cell>|<\cell>
          <overlay-from|6|<math|\<searrow\>>|>
        </cell>|<\cell>
          \;
        </cell>|<\cell>
          \;
        </cell>>|<row|<\cell>
          \;
        </cell>|<\cell>
          \;
        </cell>|<\cell>
          <overlay-from|6|Lower bounds, intrinsic hardness|>
        </cell>|<\cell>
          \;
        </cell>>>>
      </wide-tabular>
    </overlays-phantoms>

    \;
  </hidden>|<\hidden>
    <tit|Traditional complexity theory>

    <unroll|<\shown>
      <math|X> can be solved fast <math|:<space|-1.4spc>\<Longleftrightarrow\>>
      <math|X\<in\><math-bf|P>><tiny-switch|<shown|>|<hidden|<space|2em>(Cook's
      thesis 1990)>>
    </shown>|<\hidden*>
      Complexity classes: <math|<math-ss|<strong|P>>>, <math|<math-bf|NP>>,
      <math|<math-bf|L>>, <math|<math-bf|NL>>, <math|<math-bf|EXPTIME>>,
      <text-dots>
    </hidden*>|<\hidden*>
      <math|X\<in\><math-bf|P>> : upper bound,<space|2em><math|X\<nin\><math-bf|P>>
      : lower bound<space|1em><tiny-switch|<shown|>|<hidden|<image|skull.png|1.5cm|||-0.4h>>>
    </hidden*>|<\hidden*>
      Instead: for a known hard problem <math|Y>, prove that
      <math|X\<in\><math-bf|P>\<Rightarrow\>Y\<in\><math-bf|P>\<Rightarrow\>Unlikely>
    </hidden*>|<\hidden*>
      <\equation*>
        Karp:<space|1em>SAT<around*|(|p<text| clauses>,k<text|
        literals>|)><long-arrow|\<rubber-rightarrow\>|<text|reduces>>CLIQUE<around*|(|p*k<text|
        nodes>,\<leqslant\><around*|(|p*k|)><rsup|2><text| edges>|)>
      </equation*>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Criticism>

    <\compressed>
      <unroll|<\shown>
        <em|<with|color|dark red|You prove that problems are hard and I write
        computer programs that solve them>><new-line><htab|5mm>(Richard<nbsp>Jenks)
      </shown>|<\hidden*>
        <\indent>
          E.g. SAT (NP-complete) <math|\<Leftrightarrow\>> finding a solution
          to a polynomial system over <math|\<bbb-F\><rsub|2>><new-line>But
          we know how to solve big systems
        </indent>
      </hidden*>|<\hidden*>
        <vspace*|0.5fn><with|color|dark red|<em|Hardness proofs are too
        easy>>
      </hidden*>|<\hidden*>
        <\equation*>
          SAT<around*|(|p,k|)><long-arrow|\<rubber-rightarrow\>|reduces>CLIQUE<around*|(|p*k,<around*|(|p*k|)><rsup|2>|)>
        </equation*>
      </hidden*>|<\hidden*>
        <vspace*|0.5fn><with|color|dark red|<em|Asymptotic
        chararacterizations of \Pfast\Q don't work>>
      </hidden*>|<\hidden*>
        <\indent>
          Any terminating program on an actual computer runs in time
          <math|O<around*|(|1|)>>
        </indent>
      </hidden*>|<\hidden*>
        <vspace*|0.5fn><with|color|dark red|<em|Computational complexity
        classes are too shallow>>
      </hidden*>|<\hidden*>
        <\indent>
          PRIMES <math|\<in\>> <math|<math-bf|P>> and MATMULT <math|\<in\>>
          <math|<math-bf|P>>: so what?

          \Pcentral\Q problems might be more meaningful than \Pimportant\Q
          complexity classes
        </indent>
      </hidden*>>
    </compressed>
  </hidden>|<\hidden>
    <tit|Practical complexity>

    <unroll|<\shown>
      <em|<with|color|dark red|Do you want to know whether your algorithm is
      faster? Take your stopwatch and run it>><new-line><htab|5mm>(Mark van
      Hoeij)
    </shown>|<\hidden*>
      <\indent>
        <math|r\<times\>r> matrix multiplication in time
        <math|O<around*|(|r<rsup|\<omega\>>|)>> with
        <math|\<omega\>\<less\>2.3729>.<space|1em><tiny-switch|<shown|>|<hidden|Really<text-dots>?>>
      </indent>
    </hidden*>|<\hidden*>
      \;

      <with|color|dark red|<em|However>>

      <\itemize>
        <unroll|<\shown>
          <item>Stopwatches don't predict timings
        </shown>|<\hidden*>
          <item>How to reproduce timings 50 years later?
        </hidden*>|<\hidden*>
          <item>How relevant are 50 year old timings?
        </hidden*>>
      </itemize>
    </hidden*>>

    \;
  </hidden>|<\hidden>
    <tit|Criticism>

    <unroll|<\shown>
      <\compact>
        <strong|Number of forests with <math|d> nodes and height at most
        <math|1>>

        <\big-table*>
          <\with|font-size|0.84>
            <\equation*>
              <tabular*|<tformat|<cwith|1|-1|1|1|cell-lborder|1ln>|<cwith|1|-1|1|1|cell-halign|l>|<cwith|1|-1|1|1|cell-rborder|2ln>|<cwith|1|-1|2|2|cell-halign|r>|<cwith|1|-1|2|2|cell-rborder|1ln>|<cwith|1|-1|3|3|cell-halign|r>|<cwith|1|-1|3|3|cell-rborder|1ln>|<cwith|1|-1|4|4|cell-halign|r>|<cwith|1|-1|4|4|cell-rborder|1ln>|<cwith|1|-1|5|5|cell-halign|r>|<cwith|1|-1|5|5|cell-rborder|1ln>|<cwith|1|-1|6|6|cell-halign|r>|<cwith|1|-1|6|6|cell-rborder|1ln>|<cwith|1|-1|7|7|cell-halign|r>|<cwith|1|-1|7|7|cell-rborder|2ln>|<cwith|1|-1|8|8|cell-halign|r>|<cwith|1|-1|8|8|cell-rborder|1ln>|<cwith|1|1|1|-1|cell-tborder|1ln>|<cwith|1|1|1|-1|cell-bborder|2ln>|<cwith|2|2|1|-1|cell-bborder|1ln>|<cwith|3|3|1|-1|cell-bborder|1ln>|<cwith|4|4|1|-1|cell-bborder|1ln>|<cwith|1|4|8|8|cell-rborder|1ln>|<cwith|1|1|8|8|cell-tborder|1ln>|<cwith|1|1|8|8|cell-bborder|2ln>|<cwith|2|2|8|8|cell-bborder|1ln>|<cwith|3|3|8|8|cell-bborder|1ln>|<cwith|4|4|8|8|cell-bborder|1ln>|<cwith|1|4|8|8|cell-halign|c>|<table|<row|<cell|<text|Multiplication>>|<cell|10>|<cell|20>|<cell|50>|<cell|100>|<cell|200>|<cell|500>|<cell|<text|Complexity>>>|<row|<cell|<text|Naive>>|<cell|0.025>|<cell|0.072>|<cell|0.417>|<cell|2.194>|<cell|16.62>|<cell|446.34>|<cell|O<around*|(|d<rsup|2>|)>>>|<row|<cell|<text|DAC>>|<cell|0.029>|<cell|0.101>|<cell|0.641>|<cell|3.614>|<cell|30.45>|<cell|918.78>|<cell|O<around*|(|d<rsup|log
              3/log 2>|)>>>|<row|<cell|<text|Fast>>|<cell|0.038>|<cell|0.125>|<cell|0.800>|<cell|4.190>|<cell|30.96>|<cell|430.92>|<cell|d<around*|(|log
              d|)><rsup|2+o<around*|(|1|)>>>>>>>
            </equation*>
          </with>

          <label|zexptab2>
        </big-table*|Time in seconds to expand
        <math|\<mathe\><rsup|z*\<mathe\><rsup|<with|math-level|1|z>>>> at
        various orders, using rational coefficients.>

        <switch|<\shown>
          \;
        </shown>|<\hidden>
          <\big-table*>
            <\with|font-size|0.84>
              <\equation*>
                <tabular*|<tformat|<cwith|1|-1|1|1|cell-lborder|1ln>|<cwith|1|-1|1|1|cell-halign|l>|<cwith|1|-1|1|1|cell-rborder|2ln>|<cwith|1|-1|2|2|cell-halign|r>|<cwith|1|-1|2|2|cell-rborder|1ln>|<cwith|1|-1|3|3|cell-halign|r>|<cwith|1|-1|3|3|cell-rborder|1ln>|<cwith|1|-1|4|4|cell-halign|r>|<cwith|1|-1|4|4|cell-rborder|1ln>|<cwith|1|-1|5|5|cell-halign|r>|<cwith|1|-1|5|5|cell-rborder|1ln>|<cwith|1|-1|6|6|cell-halign|r>|<cwith|1|-1|6|6|cell-rborder|1ln>|<cwith|1|-1|7|7|cell-halign|r>|<cwith|1|-1|7|7|cell-rborder|1ln>|<cwith|1|-1|8|8|cell-halign|r>|<cwith|1|-1|8|8|cell-rborder|1ln>|<cwith|1|-1|9|9|cell-halign|r>|<cwith|1|-1|9|9|cell-rborder|2ln>|<cwith|1|-1|10|10|cell-rborder|1ln>|<cwith|1|1|1|-1|cell-tborder|1ln>|<cwith|1|1|1|-1|cell-bborder|2ln>|<cwith|2|2|1|-1|cell-bborder|1ln>|<cwith|3|3|1|-1|cell-bborder|1ln>|<cwith|4|4|1|-1|cell-bborder|1ln>|<cwith|1|-1|10|10|cell-halign|c>|<table|<row|<cell|<text|Multiplication>>|<cell|10>|<cell|20>|<cell|50>|<cell|100>|<cell|200>|<cell|500>|<cell|1000>|<cell|2000>|<cell|<text|Complexity>>>|<row|<cell|<text|Naive>>|<cell|0.048>|<cell|0.282>|<cell|2.533>|<cell|11.474>|<cell|48.86>|<cell|317.00>|<cell|1283.8>|<cell|>|<cell|O<around*|(|d<rsup|2>|)>>>|<row|<cell|<text|DAC>>|<cell|0.079>|<cell|0.309>|<cell|1.428>|<cell|4.384>|<cell|13.19>|<cell|61.35>|<cell|1887.4>|<cell|>|<cell|O<around*|(|d<rsup|log
                3/log 2>|)>>>|<row|<cell|<text|Fast>>|<cell|0.061>|<cell|0.331>|<cell|2.162>|<cell|7.583>|<cell|25.10>|<cell|96.20>|<cell|307.2>|<cell|959>|<cell|d<around*|(|log
                d|)><rsup|2+o<around*|(|1|)>>>>>>>
              </equation*>
            </with>

            <label|zexptab1>
          </big-table*|Time in seconds to expand
          <math|\<mathe\><rsup|z*\<mathe\><rsup|<with|math-level|1|z>>>>,
          using 10000-bit floating point coefficients.>
        </hidden>|<\hidden>
          <strong|Problem:> <math|n>-bit gcd computations in GMP used a naive
          <math|O<around*|(|n<rsup|2>|)>> algorithm (!)
        </hidden>>
      </compact>
    </shown>|<\hidden*>
      <strong|Similarly:> obsolete industry to avoid computations in
      <math|\<bbb-Q\>> (variants Bareiss' algorithm)
    </hidden*>|<\hidden*>
      <strong|Today:> what about \Prational\Q algorithms <em|<abbr|vs.>>
      computations in algebraic extensions?
    </hidden*>|<\hidden*>
      <strong|Today:> what about higher reliance on symbolic-numerical
      algorithms?
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Complexity at ISSAC>

    <unroll|<\shown>
      <center|<block|<tformat|<cwith|1|-1|2|-1|cell-halign|r>|<cwith|2|2|1|1|cell-bborder|1ln>|<cwith|3|3|1|1|cell-tborder|1ln>|<cwith|2|2|1|1|cell-lborder|0ln>|<cwith|1|1|1|1|cell-tborder|0ln>|<cwith|1|1|1|1|cell-bborder|0ln>|<cwith|2|2|1|1|cell-tborder|0ln>|<cwith|1|1|1|1|cell-lborder|0ln>|<cwith|1|1|2|-1|cell-lborder|0ln>|<cwith|1|1|2|-1|cell-rborder|0ln>|<cwith|1|1|2|-1|cell-tborder|0ln>|<cwith|1|1|2|2|cell-lborder|0ln>|<cwith|1|1|1|1|cell-rborder|0ln>|<cwith|1|1|6|6|cell-rborder|0ln>|<cwith|2|2|2|-1|cell-lborder|0ln>|<cwith|2|2|2|-1|cell-rborder|0ln>|<cwith|2|2|2|-1|cell-tborder|0ln>|<cwith|1|1|2|-1|cell-bborder|0ln>|<cwith|2|2|2|-1|cell-bborder|1ln>|<cwith|3|3|2|-1|cell-tborder|1ln>|<cwith|2|2|2|2|cell-lborder|0ln>|<cwith|2|2|1|1|cell-rborder|0ln>|<cwith|2|2|6|6|cell-rborder|0ln>|<cwith|1|1|2|-1|cell-halign|c>|<table|<row|<cell|>|<cell|<small|1997>>|<cell|<small|2004>>|<cell|<small|2012>>|<cell|<small|2017>>|<cell|<small|2021>>>|<row|<cell|>|<cell|<image|issac-1997.jpg||4cm||>>|<cell|<image|issac-2004.jpg||3.9cm||>>|<cell|<image|issac-2012.jpg||3.9cm||>>|<cell|<image|issac-2017.jpg||3.9cm||>>|<cell|<image|issac-2021.png||3.9cm||>>>|<row|<cell|None>|<cell|53%>|<cell|47%>|<cell|27%>|<cell|28%>|<cell|37%>>|<row|<cell|Benchmarks>|<cell|17%>|<cell|30%>|<cell|22%>|<cell|24%>|<cell|24%>>|<row|<cell|Complexity
      analysis>|<cell|22%>|<cell|9%>|<cell|27%>|<cell|39%>|<cell|29%>>|<row|<cell|Both>|<cell|8%>|<cell|14%>|<cell|24%>|<cell|9%>|<cell|10%>>>>>>
    </shown>|<\hidden*>
      <\overlays-phantoms|1|3>
        <\wide-tabular>
          <tformat|<cwith|1|-1|2|2|cell-halign|c>|<cwith|1|1|1|-1|cell-background|#A04000>|<cwith|1|-1|1|1|cell-lsep|1spc>|<cwith|1|-1|2|2|cell-rsep|1spc>|<table|<row|<\cell>
            <with|color|white|Compared with>
          </cell>|<\cell>
            <with|color|white|Benchmarks>
          </cell>>|<row|<\cell>
            Roughgarden (ed.), <em|Beyond the worst-case analysis of
            algorithms>, 686p
          </cell>|<\cell>
            1
          </cell>>|<row|<\cell>
            <overlay-from|2|Flajolet & Sedgewick, <em|An introduction to the
            analysis of algorithms>, 572p|>
          </cell>|<\cell>
            <overlay-from|2|0|>
          </cell>>|<row|<\cell>
            <overlay-from|3|Knuth, <em|The art of computer programming,
            <abbr|vol.> 2>, 688p|>
          </cell>|<\cell>
            <overlay-from|3|0|>
          </cell>>>>
        </wide-tabular>
      </overlays-phantoms>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Amended computational complexity>

    <\compressed>
      <vspace*|0.5fn><strong|Classical>

      Average performance

      Randomized algorithms<vspace|1fn>
    </compressed>

    <\overlays-phantoms|1|10>
      <\wide-tabular>
        <tformat|<cwith|1|-1|1|-1|cell-bsep|1spc>|<cwith|1|-1|1|-1|cell-tsep|1spc>|<cwith|6|6|1|-1|cell-bsep|3spc>|<table|<row|<\cell>
          <overlay-from|2|<strong|Current trends>|>
        </cell>|<\cell>
          <overlay-from|6|<strong|Personal experience>|>
        </cell>>|<row|<\cell>
          <overlay-from|2|parameterized algorithms|>
        </cell>|<\cell>
          <overlay-from|6|amortized complexity<htab|5mm><small|(multi-point
          evaluation)>|>
        </cell>>|<row|<\cell>
          <overlay-from|3|instance optimality|>
        </cell>|<\cell>
          <overlay-from|7|conjectured complexity<htab|5mm><small|(multplication
          in <math|\<bbb-F\><rsub|p><around*|[|x|]>>)>|>
        </cell>>|<row|<\cell>
          <overlay-from|4|resource augmentation|>
        </cell>|<\cell>
          <overlay-from|8|heuristic complexity<htab|5mm><small|(sparse
          multplication)>|>
        </cell>>|<row|<\cell>
          <overlay-from|4|self-improving algorithms|>
        </cell>|<\cell>
          <overlay-from|9|irregular complexity<htab|5mm><small|(arithmetic
          over <math|\<bbb-F\><rsub|p<rsup|\<lambda\>>>>)>|>
        </cell>>|<row|<\cell>
          <overlay-from|4|smooth analysis|>
        </cell>|<\cell>
          \;
        </cell>>|<row|<\cell>
          <overlay-from|5|more realistic complexity
          classes|><htab|5mm><space|2em>
        </cell>|<\cell>
          <overlay-from|10|fundamental complexities|>
        </cell>>>>
      </wide-tabular>
    </overlays-phantoms>
  </hidden>|<\hidden>
    <tit|Fundamental complexities>

    <\wide-tabular>
      <tformat|<cwith|1|-1|2|2|cell-hpart|1>|<table|<row|<\cell>
        <math|<math-ss|I><around*|(|n|)>>
      </cell>|<\cell>
        cost to multiply two <math|n>-bit integers
      </cell>>|<row|<\cell>
        <math|<math-ss|M><around*|(|d|)>>
      </cell>|<\cell>
        cost to multiply two polynomials of degree <math|d>
      </cell>>|<row|<\cell>
        <math|O<around*|(|r<rsup|\<omega\>>|)>>
      </cell>|<\cell>
        cost to multiply two <math|r\<times\>r> matrices
      </cell>>|<row|<\cell>
        <math|L<rsub|n><around*|[|\<alpha\>,c|]>><space|1em>
      </cell>|<\cell>
        <math|\<mathe\><rsup|<around*|(|c+o<around*|(|1|)>|)>*<around*|(|log
        n|)><rsup|\<alpha\>>*<around*|(|log log n|)><rsup|1-\<alpha\>>>>,
        factoring <math|n\<in\>\<bbb-N\>> using number sieve:
        <math|L<rsub|n><around*|[|<frac|1|3>,<sqrt|<frac|64|9>|3>|]>>
      </cell>>>>
    </wide-tabular>

    \;

    <\overlays-phantoms|1|7>
      <\wide-tabular>
        <tformat|<cwith|2|2|1|1|cell-hpart|1>|<cwith|2|2|3|3|cell-hpart|1>|<cwith|1|-1|1|-1|cell-bsep|1spc>|<cwith|1|-1|1|-1|cell-tsep|1spc>|<cwith|2|2|1|-1|cell-bsep|3spc>|<table|<row|<\cell>
          \;
        </cell>|<\cell>
          \;
        </cell>|<\cell>
          <draw-over|<space|18em>|<with|gr-mode|<tuple|edit|text-at>|gr-color|dark
          red|gr-text-at-halign|center|gr-proviso|<show-from|1>|gr-arrow-end|\<gtr\>|<graphics|<with|color|dark
          red|proviso|<show-from|4>|<arc|<point|-1.90705|-0.282219>|<point|-1.31817044174697|-0.166374671505444>|<point|-0.729293669664086|-0.282219282406994>>>|<with|color|dark
          red|proviso|<show-from|4>|<arc|<point|0.458114|-0.291873>|<point|0.776686272056063|-0.195335824230831>|<point|1.12422010476071|-0.291872999982123>>>|<with|color|dark
          red|proviso|<show-from|4>|text-at-halign|center|<text-at|relates|<point|-0.294876378783274|0.229427749074852>>>|<with|color|dark
          red|arrow-end|\<gtr\>|proviso|<show-from|4>|arrow-begin|\<less\>|<spline|<point|-1.31817|-0.166375>|<point|-1.11544237266925|0.0556608327225271>|<point|-0.294876378783274|0.132059280976813>|<point|0.564304485403222|0.0363533975722688>|<point|0.776686272056063|-0.195335824230831>>>|<with|color|dark
          red|proviso|<show-from|5>|<arc|<point|1.28833|-0.301527>|<point|1.67448200654308|-0.195335824230831>|<point|2.0123621216726|-0.282219282406994>>>|<with|color|dark
          red|arrow-end|\<gtr\>|proviso|<show-from|5>|<line|<point|1.66483|0.0749683>|<point|1.67448200654308|-0.195335824230831>>>|<with|color|dark
          red|proviso|<show-from|5>|text-at-halign|center|<text-at|dichotomy?|<point|1.66483|0.200467>>>>>|2cm>
        </cell>>|<row|<\cell>
          <\overlay-from|2>
            <\equation*>
              PRIMES\<in\><math-bf|P>
            </equation*>
          </overlay-from|>
        </cell>|<\cell>
          <overlay-from|2|<with|color|dark red|versus>|>
        </cell>|<\cell>
          <\overlay-from|2>
            <\equation*>
              GCD<around*|(|d|)>=O<around*|(|<math-ss|M><around*|(|d|)>*log
              d|)>
            </equation*>
          </overlay-from|>
        </cell>>|<row|<\cell>
          <\overlay-from|3>
            <\itemize>
              <item>Pigeonholes your problem
            </itemize>
          </overlay-from|>
        </cell>|<\cell>
          \;
        </cell>|<\cell>
          <\overlay-from|3>
            <\itemize>
              <item>Tweets a story
            </itemize>
          </overlay-from|>
        </cell>>|<row|<\cell>
          <\overlay-from|6>
            <\itemize>
              <item><with|condensed-factor|0.95|<condensed|FACTOR<math|\<nin\><math-bf|P>>
              on normal computer?>>
            </itemize>
          </overlay-from|>
        </cell>|<\cell>
          \;
        </cell>|<\cell>
          <\overlay-from|6>
            <\itemize>
              <item>Hardware oblivious<space|8em>
            </itemize>
          </overlay-from|>
        </cell>>|<row|<\cell>
          <\overlay-from|6>
            <phantom|<item>><with|condensed-factor|0.95|<condensed|FACTOR<math|\<in\><math-bf|P>>
            on quantum computer>>
          </overlay-from|>
        </cell>|<\cell>
          \;
        </cell>|<\cell>
          <\overlay-from|7>
            <\itemize>
              <item>Accurate for modeling
            </itemize>

            <\equation*>
              <math-ss|GCD><around*|(|d|)>\<leqslant\><around*|(|10+o<around*|(|1|)>|)>*<math-ss|M><around*|(|d|)>*log<rsub|2>
              d
            </equation*>
          </overlay-from|>
        </cell>>>>
      </wide-tabular>
    </overlays-phantoms>

    \;
  </hidden>|<\hidden>
    <tit|Back to our stopwatch>

    <strong|What story do you wish to convey?>

    <switch|<\shown>
      <\wide-tabular>
        <tformat|<cwith|1|1|2|2|cell-halign|c>|<cwith|1|1|1|-1|cell-bsep|1spc>|<table|<row|<\cell>
          <\equation*>
            <wide|O|~><around*|(|r<rsup|\<omega\>>|)>
          </equation*>
        </cell>|<\cell>
          <with|color|dark red|versus>
        </cell>|<\cell>
          <\equation*>
            O<around*|(|r<rsup|3>|)>
          </equation*>
        </cell>>|<row|<\cell>
          <\equation*>
            <phantom|O<around*|(|r<rsup|\<omega\>>*log<rsub|2> r|)>>
          </equation*>
        </cell>|<\cell>
          \;
        </cell>|<\cell>
          <\equation*>
            <phantom|O<around*|(|r<rsup|\<omega\>>*log<rsub|2> r|)>>
          </equation*>
        </cell>>>>
      </wide-tabular>
    </shown>|<\hidden>
      <\wide-tabular>
        <tformat|<cwith|1|1|2|2|cell-halign|c>|<cwith|1|1|1|-1|cell-bsep|1spc>|<table|<row|<\cell>
          <\equation*>
            <wide|O|~><around*|(|r<rsup|\<omega\>>|)>
          </equation*>
        </cell>|<\cell>
          <with|color|dark red|versus>
        </cell>|<\cell>
          <\equation*>
            O<around*|(|r<rsup|3>|)>
          </equation*>
        </cell>>|<row|<\cell>
          <\equation*>
            O<around*|(|r<rsup|\<omega\>>*log<rsub|2> r|)>
          </equation*>
        </cell>|<\cell>
          \;
        </cell>|<\cell>
          <\equation*>
            <phantom|O<around*|(|r<rsup|\<omega\>>*log<rsub|2> r|)>>
          </equation*>
        </cell>>>>
      </wide-tabular>
    </hidden>|<\hidden>
      <\wide-tabular>
        <tformat|<cwith|1|1|2|2|cell-halign|c>|<cwith|1|1|1|-1|cell-bsep|1spc>|<table|<row|<\cell>
          <\equation*>
            <wide|O|~><around*|(|r<rsup|\<omega\>>|)>
          </equation*>
        </cell>|<\cell>
          <with|color|dark red|versus>
        </cell>|<\cell>
          <\equation*>
            O<around*|(|r<rsup|3>|)>
          </equation*>
        </cell>>|<row|<\cell>
          <\equation*>
            O<around*|(|r<rsup|\<omega\>>*log<rsub|2> r|)>
          </equation*>
        </cell>|<\cell>
          \;
        </cell>|<\cell>
          <\equation*>
            <phantom|O<around*|(|r<rsup|\<omega\>>*log<rsub|2> r|)>>
          </equation*>
        </cell>>>>
      </wide-tabular>

      \;

      <switch|<\shown>
        <\wide-tabular>
          <tformat|<cwith|1|1|1|1|cell-valign|t>|<table|<row|<\cell>
            <space|1em><bend-in-shadow|<with|ornament-color|<pattern|vintage/paper-ridged-light.png|2cm|100@>|<\ornament>
              <\with|font|greek=pagella,math=pagella,Bradley
              Hand|font-family|handwritten>
                <tiny-switch|<shown|<tabular|<tformat|<cwith|1|-1|1|1|cell-halign|r>|<table|<row|<cell|Naive:>|<cell|C<rsub|N>
                r<rsup|<space|0.6spc>3>>>|<row|<cell|Strassen:>|<cell|C<rsub|S>
                r<rsup|<space|0.6spc>2.81>>>|<row|<cell|Best:>|<cell|C<rsub|B>
                r<rsup|<space|0.6spc>2.37>>>>>>>|<\hidden>
                  <tabular|<tformat|<cwith|1|-1|1|1|cell-halign|r>|<table|<row|<cell|Naive:>|<cell|C<rsub|N>
                  r<rsup|<space|0.6spc>3>>>|<row|<cell|Strassen:>|<cell|C<rsub|S>
                  r<rsup|<space|0.6spc>2.81>>>|<row|<cell|Best:>|<cell|C<rsub|B>
                  r<rsup|<space|0.6spc>2.37>>>>>>

                  \;

                  Crossover point: <tabular|<tformat|<twith|table-valign|T>|<table|<row|<cell|C<rsub|N>
                  r<rsub|NS><rsup|<space|0.6spc>3> = C<rsub|S>
                  r<rsub|NS><rsup|<space|0.6spc>2.81>>>|<row|<cell|r<rsub|NS>
                  \<approx\> 1000>>>>>
                </hidden>|<\hidden>
                  <tabular|<tformat|<cwith|1|-1|1|1|cell-halign|r>|<table|<row|<cell|Naive:>|<cell|C<rsub|N>
                  r<rsup|<space|0.6spc>3>>>|<row|<cell|Strassen:>|<cell|C<rsub|S>
                  r<rsup|<space|0.6spc>2.81>>>|<row|<cell|Best:>|<cell|C<rsub|B>
                  r<rsup|<space|0.6spc>2.37>>>>>>

                  \;

                  Crossover point: <tabular|<tformat|<twith|table-valign|T>|<table|<row|<cell|C<rsub|N>
                  r<rsub|NS><rsup|<space|0.6spc>3> = C<rsub|S>
                  r<rsub|NS><rsup|<space|0.6spc>2.81>>>|<row|<cell|r<rsub|NS>
                  \<approx\> 1000>>>>>

                  \;

                  Gain two: <tabular|<tformat|<twith|table-valign|T>|<table|<row|<cell|C<rsub|N>
                  r<rsup|<space|0.6spc>3> = 2 C<rsub|S>
                  r<rsup|<space|0.6spc>2.81>>>|<row|<cell|r \<approx\>
                  32000>>>>>
                </hidden>>
              </with>
            </ornament>>>
          </cell>|<\cell>
            \;
          </cell>>>>
        </wide-tabular>
      </shown>|<\hidden>
        <\wide-tabular>
          <tformat|<cwith|1|1|1|1|cell-valign|t>|<cwith|1|1|1|1|cell-bsep|1em>|<table|<row|<\cell>
            <space|1em><bend-in-shadow|<with|ornament-color|<pattern|vintage/paper-ridged-light.png|2cm|100@>|<\ornament>
              <\with|font|greek=pagella,math=pagella,Bradley
              Hand|font-family|handwritten>
                <tabular|<tformat|<cwith|1|-1|1|1|cell-halign|r>|<table|<row|<cell|Naive:>|<cell|C<rsub|N>
                r<rsup|<space|0.6spc>3>>>|<row|<cell|Strassen:>|<cell|C<rsub|S>
                r<rsup|<space|0.6spc>2.81>>>|<row|<cell|Best:>|<cell|C<rsub|B>
                r<rsup|<space|0.6spc>2.37>>>>>>

                \;

                Crossover point: <tabular|<tformat|<twith|table-valign|T>|<table|<row|<cell|C<rsub|N>
                r<rsub|NS><rsup|<space|0.6spc>3> = C<rsub|S>
                r<rsub|NS><rsup|<space|0.6spc>2.81>>>|<row|<cell|r<rsub|NS>
                \<approx\> 1000>>>>>

                \;

                Gain two: <tabular|<tformat|<twith|table-valign|T>|<table|<row|<cell|C<rsub|N>
                r<rsup|<space|0.6spc>3> = 2 C<rsub|S>
                r<rsup|<space|0.6spc>2.81>>>|<row|<cell|r \<approx\>
                32000>>>>>
              </with>
            </ornament>>>
          </cell>|<\cell>
            <space|2em><bend-in-shadow|<with|ornament-color|<pattern|lines-basic/lines-basic-45-05.png|4cm|100@|<eff-recolor|0|#c2e5ed>>|<\ornament>
              <\with|font|greek=pagella,math=pagella,Bradley
              Hand|font-family|handwritten>
                <tabular|<tformat|<cwith|2|-1|1|1|cell-halign|r>|<cwith|2|-1|2|2|cell-halign|r>|<cwith|2|-1|3|3|cell-halign|c>|<cwith|1|1|1|-1|cell-halign|c>|<table|<row|<cell|<space|1em>r>|<cell|
                log<rsub|2> r>|<cell| log<rsub|2> log<rsub|2>
                r>>|<row|<cell|10<rsup|3>>|<cell|10>|<cell|3.3>>|<row|<cell|10<rsup|6>>|<cell|20>|<cell|4.3>>|<row|<cell|10<rsup|9>>|<cell|30>|<cell|4.9>>|<row|<cell|10<rsup|12>>|<cell|40>|<cell|5.3>>|<row|<cell|10<rsup|15>>|<cell|50>|<cell|5.6>>|<row|<cell|10<rsup|100>>|<cell|332>|<cell|8.4>>>>>
              </with>
            </ornament>>>
          </cell>>>>
        </wide-tabular>
      </hidden>>

      <space|2em>
    </hidden>>
  </hidden>|<\hidden>
    <tit|Anatomy of a computer algebra system>

    <\overlays|1|3>
      <with|gr-mode|<tuple|edit|text-at>|gr-frame|<tuple|scale|1cm|<tuple|0.500001gw|0.499999gh>>|gr-geometry|<tuple|geometry|1par|0.526076par|center>|gr-grid|<tuple|empty>|gr-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-aspect|<tuple|<tuple|axes|none>|<tuple|1|none>|<tuple|4|none>>|gr-edit-grid|<tuple|empty>|gr-edit-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-grid-aspect|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|4|#e0e0ff>>|gr-grid-aspect-props|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|4|#e0e0ff>>|gr-text-at-halign|center|gr-line-width|30ln|gr-proviso|<show-from|1>|<graphics||<with|text-at-halign|center|<text-at|Numbers|<point|-7.0|-5.0>>>|<with|text-at-halign|center|<text-at|Polynomials|<point|-7|-2.5>>>|<with|text-at-halign|center|<text-at|Series|<point|-10.5|0.0>>>|<with|text-at-halign|center|<text-at|Skew
      polynomials|<point|-6.5|0.0>>>|<with|text-at-halign|center|<text-at|Linear
      algebra|<point|1.75|-2.5>>>|<with|text-at-halign|center|<text-at|Algebraic
      extensions|<point|-0.75|0.0>>>|<with|text-at-halign|center|<text-at|Multivariate
      polynomials|<point|6.75|0.0>>>|<with|text-at-halign|center|<text-at|Holonomic
      functions|<point|-8.5|2.5>>>|<with|text-at-halign|center|<text-at|Creative
      telescoping|<point|-8.5|5.0>>>|<with|text-at-halign|center|<text-at|Commutative
      algebra|<point|0.5|5.0>>>|<with|text-at-halign|center|<text-at|Lists|<point|3.75|-5.0>>>|<with|text-at-halign|center|<text-at|Tables|<point|1.5|-5.0>>>|<with|text-at-halign|center|<text-at|Vectors|<point|-1.0|-5.0>>>|<line|<point|-7|-4.38128>|<point|-7.0|-2.82109075274507>>|<line|<point|-2.17476|-4.41262>|<point|-5.18694602460643|-2.82109075274507>>|<line|<point|-0.75926|-4.41262>|<point|0.554518232256496|-2.82109075274507>>|<line|<point|1.5|-4.38128>|<point|1.50247202795193|-2.82109075274507>>|<line|<point|3.75|-4.41262>|<point|2.56761535534001|-2.82109075274507>>|<line|<point|2.61126|-1.88128>|<point|5.80283362410066|-0.321090752745072>>|<line|<point|-5.18695|-1.88128>|<point|4.19653389556894|-0.321090752745072>>|<line|<point|-5.93364|-1.88128>|<point|-1.92726510244439|-0.321090752745072>>|<line|<point|-7|-1.88128>|<point|-6.97174389221802|-0.321090752745072>>|<line|<point|-8.81305|-1.88128>|<point|-10.5|-0.172294615689906>>|<line|<point|-10.5|0.595218>|<point|-10.5070654940119|2.31988358248446>>|<line|<point|-8.5|3.11872>|<point|-8.5|4.67890924725493>>|<with|text-at-halign|center|<text-at|Groebner
      bases|<point|6.75|2.5>>>|<line|<point|6.75|0.618716>|<point|6.75|2.32770538431009>>|<line|<point|4.51012|3.11872>|<point|0.5|4.67890924725493>>|<with|text-at-halign|center|<text-at|Ore
      algebras|<point|0.0|1.75>>>|<line|<point|1.86005093266305|2.14221494098798>|<point|4.51012038629448|2.72321074216166>>|<line|<point|3.20223|0.618716>|<point|1.86005093266305|1.42890924725493>>|<line|<point|-5.60595|-4.38128>|<point|-0.329325969043524|-2.82109075274507>>|<line|<point|-6.5|0.618716>|<point|-6.49538814104522|2.31988358248446>>|<line|<point|4.51012|2.92565>|<point|-5.60614830003969|4.88800374622967>>|<with|color|<pattern|/Users/vdhoeven/texmacs/src/TeXmacs/misc/patterns/vintage/wood-dark.png|1gu|>|proviso|<show-from|3>|fill-color|#eef|line-width|10ln|<carc|<point|-7.0|1.5>|<point|-3.5|-2.0>|<point|-7.0|-5.5>>>|<with|color|<pattern|/Users/vdhoeven/texmacs/src/TeXmacs/misc/patterns/vintage/wood-dark.png|1gu|>|proviso|<show-from|3>|line-width|30ln|<line|<point|-3|-6>|<point|-4.25|-4.75>>>|<with|proviso|<show-from|3>|text-at-halign|center|<text-at|Polynomials|<point|-6.99945429289589|6.44926577589628e-4>>>|<with|proviso|<show-from|3>|text-at-halign|center|<text-at|<small|Vectorial
      operations>|<point|-6.98856708200496|-1.25>>>|<with|proviso|<show-from|3>|text-at-halign|center|<text-at|<small|Division,
      GCD, LCM>|<point|-7.0|-2.99182566283756>>>|<with|proviso|<show-from|3>|text-at-halign|center|<text-at|<small|Multiplication,
      FFT>|<point|-6.99945429289589|-2.10677669003836>>>|<with|proviso|<show-from|3>|text-at-halign|center|<text-at|<small|Chinese
      remaindering>|<point|-7.0|-3.80273066748644>>>|<with|proviso|<show-from|3>|text-at-halign|center|<text-at|<small|<text-dots>>|<point|-6.92801627199365|-4.5713884111655>>>|<with|text-at-halign|center|<text-at|Polynomial
      system solving|<point|7.75|5.0>>>|<line|<point|6.75|3.11872>|<point|7.75|4.67890924725493>>|<with|color|red|proviso|<show-from|2>|dash-style|11100|line-width|2ln|<spline|<point|-11.4464710940601|3.84042201349385>|<point|-6.19577655774573|3.92971953962164>|<point|-0.409296864664638|3.09032279402037>|<point|2.7521069528559|2.33778747642985>|<point|7.66318296070909|1.48298386029898>|<point|11.4136955946554|1.42938880804339>>>>>
    </overlays>
  </hidden>|<\hidden>
    <tit|Multiplication>

    <unroll|<\shown>
      <\compressed>
        <strong|Fundamental in two ways>

        <\compact>
          <\enumerate>
            <item>Other operations \Preduce\Q to multiplication

            <item>Fast multiplication <math|\<rightsquigarrow\>> more
            efficient representations <math|\<rightsquigarrow\>> optimize
            other operations
          </enumerate>
        </compact>
      </compressed>
    </shown>|<\hidden*>
      <\compact>
        <unroll|<\shown>
          <vspace*|0.5fn><strong|Implementing a new algebra
          <math|\<bbb-A\>>><vspace|0.25fn>
        </shown>|<\hidden*>
          Naive implementation of all operations
        </hidden*>|<\hidden*>
          <space|2em>Implement faster multiplication
        </hidden*>|<\hidden*>
          <space|4em>Reimplement other operations on top of multiplication
        </hidden*>|<\hidden*>
          <space|6em>Further optimize by using more efficient representations
        </hidden*>>
      </compact>
    </hidden*>|<\hidden*>
      <htab|5mm><block|<tformat|<cwith|1|-1|3|3|cell-halign|l>|<cwith|5|5|3|3|cell-halign|l>|<cwith|1|1|1|-1|color|white>|<cwith|1|1|1|-1|cell-background|#A04000>|<table|<row|<cell|Algebra>|<cell|Complexity>|<cell|Note>>|<row|<cell|<math|\<bbb-Z\>>>|<cell|<math|O<around*|(|n*log
      n|)>>>|<cell|bit complexity>>|<row|<cell|<math|\<bbb-K\><around*|[|x|]>>>|<cell|<math|O<around*|(|d*log
      d*log log d|)>>>|<cell|algebraic>>|<row|<cell|>|<cell|<math|O*<around*|(|d*log
      d*4<rsup|log<rsup|\<ast\>> d>|)>>>|<cell|<math|char \<bbb-K\>\<gtr\>0>
      >>|<row|<cell|>|<cell|<math|O<around*|(|d*log d|)>>>|<cell|<math|char
      \<bbb-K\>\<gtr\>0>, conjectured>>|<row|<cell|<math|\<bbb-K\><rsup|r\<times\>r>>>|<cell|<math|O<around*|(|r<rsup|\<omega\>>|)>,<space|1.2spc>\<omega\>\<less\>2.3729>>|<cell|algebraic>>>>><htab|5mm>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Multiplication (continued)>

    \;

    <htab|5mm><block|<tformat|<cwith|1|-1|3|3|cell-halign|l>|<cwith|7|7|1|1|cell-valign|c>|<cwith|1|1|1|-1|color|white>|<cwith|1|-1|1|-1|cell-bsep|1spc>|<cwith|1|-1|1|-1|cell-tsep|1spc>|<cwith|1|-1|1|-1|cell-lsep|1.5spc>|<cwith|1|-1|1|-1|cell-rsep|1.5spc>|<cwith|1|1|1|-1|cell-background|#A04000>|<table|<row|<cell|Algebra>|<cell|Complexity>|<cell|Notes>>|<row|<cell|<math|\<bbb-Z\><rsub|p>>>|<cell|<math|<math-ss|I><around*|(|n|)>*\<mathe\><rsup|O<around*|(|<sqrt|log
    log n>|)>>>>|<cell|relaxed>>|<row|<cell|<math|\<bbb-K\><around*|[|<around*|[|z|]>|]>>>|<cell|<math|<math-ss|M><around*|(|d|)>*\<mathe\><rsup|O<around*|(|<sqrt|log
    log d>|)>>>>|<cell|relaxed>>|<row|<cell|<math|\<bbb-K\><rsup|r\<times\>r><around*|[|x|]>>>|<cell|<math|O<around*|(|r<rsup|2>*<math-ss|M><around*|(|d|)>+r<rsup|\<omega\>>*d|)>>>|<cell|>>|<row|<cell|<math|\<bbb-K\><around*|[|x,\<partial\><rsub|x>|]>>>|<cell|<math|O<around*|(|r*<math-ss|M><around*|(|d|)>*log
    d+r<rsup|\<omega\>-1>*d|)>>>|<cell|<math|d\<geqslant\>r=deg<rsub|\<partial\>>>>>|<row|<cell|>|<cell|<math|O<around*|(|d*<math-ss|M><around*|(|r|)>*log
    r+d<rsup|\<omega\>-1>*r|)>>>|<cell|<math|r\<geqslant\>d>>>|<row|<cell|<math|<above|\<bbb-L\>\<divides\>\<bbb-K\>|<text|tower>>>>|<cell|<math|<math-ss|M><around*|(|d|)>*\<mathe\><rsup|O<around*|(|<sqrt|log
    d>|)>>>>|<cell|<math|d=<around*|[|\<bbb-L\>\<over\>\<bbb-K\>|]>>>>|<row|<cell|<math|\<bbb-K\><around*|[|\<b-x\>|]>>>|<cell|<math|O<around*|(|<math-ss|M><around*|(|s|)>|)>>>|<cell|<math|s>
    sparse size, heuristic>>>>><htab|5mm>
  </hidden>|<\hidden>
    <tit|Change of representation>

    (Usually through evaluation\Uinterpolation)<vspace|0.5fn>

    <\overlays-greyed|1|7>
      <\eqnarray*>
        <tformat|<cwith|5|5|3|3|cell-bsep|>|<table|<row|<cell|\<bbb-A\><around*|[|\<mathi\>|]>\<ni\>x+y*\<mathi\>>|<cell|<long-arrow|\<rubber-leftrightarrow\>|Karatsuba>>|<cell|<around*|(|x,y,x+y|)>\<in\>\<bbb-A\><rsup|3>>>|<row|<cell|<overlay-from|2|\<bbb-A\><around*|[|x|]>\<ni\>P<around*|(|x|)>|>>|<cell|<overlay-from|2|<long-arrow|\<rubber-leftrightarrow\>|<space|1em>DFT<rsub|\<omega\>><space|1em>>|>>|<cell|<overlay-from|2|<around*|(|P<around*|(|1|)>,P<around*|(|\<omega\>|)>,\<ldots\>,P<around*|(|\<omega\><rsup|d-1>|)>|)>\<in\>\<bbb-A\><rsup|d>|>>>|<row|<cell|<overlay-from|3|\<bbb-A\><rsup|r\<times\>r><around*|[|x|]>\<ni\>P<around*|(|x|)>|>>|<cell|<overlay-from|3|<long-arrow|\<rubber-leftrightarrow\>|<space|1em>DFT<rsub|\<omega\>><space|1em>>|>>|<cell|<overlay-from|3|<around*|(|P<around*|(|1|)>,P<around*|(|\<omega\>|)>,\<ldots\>,P<around*|(|\<omega\><rsup|d-1>|)>|)>\<in\><around*|(|\<bbb-A\><rsup|r\<times\>r>|)><rsup|d>|>>>|<row|<cell|<overlay-from|4|\<bbb-K\><around*|[|x,\<partial\>|]>\<ni\>L|>>|<cell|<overlay-from|4|<long-arrow|\<rubber-leftrightarrow\>|<space|5em>>|>>|<cell|<overlay-from|4|Mat<around*|(|v\<longmapsto\>L
        v|)><text| w.r.t. suitable bases>|>>>|<row|<cell|<overlay-from|5|\<bbb-K\><around*|[|\<b-x\>|]>\<ni\>P<around*|(|x<rsub|1>,\<ldots\>,x<rsub|n>|)>|>>|<cell|<overlay-from|5|<long-arrow|\<rubber-leftrightarrow\>|<space|5em>>|>>|<cell|<overlay-from|5|<around*|(|P<around*|(|\<omega\><rsup|\<alpha\><rsub|1>*k>,\<ldots\>,\<omega\><rsup|\<alpha\><rsub|n>*k>|)>|)><rsub|1\<leqslant\>k\<leqslant\>s>|>>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|<overlay-from|6|\<bbb-Z\>\<ni\>k|>>|<cell|<overlay-from|6|<long-arrow|\<rubber-leftrightarrow\>|<space|1em>CRT<space|1em>>|>>|<cell|<overlay-from|6|<around*|(|k
        mod p<rsub|i>|)><rsub|1\<leqslant\>i\<leqslant\>\<ell\>>\<in\>\<bbb-Z\>/<around*|\<nobracket\>|p<rsub|1>*\<bbb-Z\>|\<nobracket\>>\<times\>\<cdots\>\<times\>\<bbb-Z\>/<around*|\<nobracket\>|p<rsub|\<ell\>>*\<bbb-Z\>|\<nobracket\>>|>>>|<row|<cell|<overlay-from|7|\<bbb-K\><around*|[|\<alpha\><rsub|1>,\<ldots\>,\<alpha\><rsub|t>|]>/<around*|(|\<mu\><rsub|1>,\<ldots\>,\<mu\><rsub|t>|)>\<ni\>x|>>|<cell|<overlay-from|7|<long-arrow|\<rubber-leftrightarrow\>|<space|5em>>|>>|<cell|<overlay-from|7|<wide|x|~>\<in\>\<bbb-K\><around*|[|\<beta\><rsub|1>,\<ldots\>,\<beta\><rsub|u>|]>/<around*|(|\<nu\><rsub|1>,\<ldots\>,\<nu\><rsub|u>|)>,<space|2em>u\<ll\>t|>>>>>
      </eqnarray*>
    </overlays-greyed>
  </hidden>|<\hidden>
    <tit|Other operations>

    <htab|5mm><tiny-switch|<shown|<block|<tformat|<cwith|1|1|3|3|cell-halign|l>|<cwith|1|1|1|3|color|white>|<cwith|1|1|1|3|cell-lsep|1.5spc>|<cwith|1|1|1|3|cell-rsep|1.5spc>|<cwith|1|1|1|3|cell-background|#A04000>|<cwith|2|-1|1|-1|cell-lsep|1.5spc>|<cwith|2|-1|1|-1|cell-rsep|1.5spc>|<cwith|1|-1|1|-1|cell-bsep|1spc>|<cwith|1|-1|1|-1|cell-tsep|1spc>|<cwith|2|5|3|3|cell-lsep|1.5spc>|<cwith|2|5|3|3|cell-rsep|1.5spc>|<cwith|2|5|3|3|cell-bsep|1spc>|<cwith|2|5|3|3|cell-tsep|1spc>|<table|<row|<cell|Operation>|<cell|Over
    <math|<with|color|white|\<bbb-Z\>>> or
    <math|<with|color|white|\<bbb-C\>>>>|<cell|Over
    <math|<with|color|white|\<bbb-K\><around*|[|x|]>>> or
    <math|<with|color|white|\<bbb-K\><around*|[|<around*|[|z|]>|]>>>>>|<row|<cell|Quotient
    + remainder>|<cell|<math|\<sim\>2*<math-ss|I><around*|(|n|)>>>|<cell|<math|\<sim\>2*<math-ss|M><around*|(|d|)>>>>|<row|<cell|Reciprocal>|<cell|<math|\<sim\><frac*|13|9>*<math-ss|I><around*|(|n|)>><space|3.5em>>|<cell|<math|\<sim\><frac*|13|9>*<math-ss|M><around*|(|d|)>>>>|<row|<cell|Square
    root>|<cell|<math|\<sim\><frac*|4|3>*<math-ss|I><around*|(|n|)>>>|<cell|<math|\<sim\><frac*|4|3>*<math-ss|M><around*|(|d|)>>>>>>>>|<hidden|<block|<tformat|<cwith|1|1|3|3|cell-halign|l>|<cwith|1|1|1|3|color|white>|<cwith|1|1|1|3|cell-lsep|1.5spc>|<cwith|1|1|1|3|cell-rsep|1.5spc>|<cwith|1|1|1|3|cell-background|#A04000>|<cwith|2|-1|1|-1|cell-lsep|1.5spc>|<cwith|2|-1|1|-1|cell-rsep|1.5spc>|<cwith|1|-1|1|-1|cell-bsep|1spc>|<cwith|1|-1|1|-1|cell-tsep|1spc>|<cwith|2|7|3|3|cell-lsep|1.5spc>|<cwith|2|7|3|3|cell-rsep|1.5spc>|<cwith|2|7|3|3|cell-bsep|1spc>|<cwith|2|7|3|3|cell-tsep|1spc>|<table|<row|<cell|Operation>|<cell|Over
    <math|<with|color|white|\<bbb-Z\>>> or
    <math|<with|color|white|\<bbb-C\>>>>|<cell|Over
    <math|<with|color|white|\<bbb-K\><around*|[|x|]>>> or
    <math|<with|color|white|\<bbb-K\><around*|[|<around*|[|z|]>|]>>>>>|<row|<cell|Quotient
    + remainder>|<cell|<math|\<sim\>2*<math-ss|I><around*|(|n|)>>>|<cell|<math|\<sim\>2*<math-ss|M><around*|(|d|)>>>>|<row|<cell|Reciprocal>|<cell|<math|\<sim\><frac*|13|9>*<math-ss|I><around*|(|n|)>><space|3.5em>>|<cell|<math|\<sim\><frac*|13|9>*<math-ss|M><around*|(|d|)>>>>|<row|<cell|Square
    root>|<cell|<math|\<sim\><frac*|4|3>*<math-ss|I><around*|(|n|)>>>|<cell|<math|\<sim\><frac*|4|3>*<math-ss|M><around*|(|d|)>>>>|<row|<cell|Gcd,
    lcm>|<cell|<math|O<around*|(|<math-ss|I><around*|(|n|)>*log
    n|)>>>|<cell|<math|O<around*|(|<math-ss|M><around*|(|d|)>*log
    d|)>>>>|<row|<cell|CRT>|<cell|<math|O<around*|(|<math-ss|I><around*|(|n|)>*log
    n|)>>>|<cell|<math|O<around*|(|<math-ss|M><around*|(|d|)>*log
    d|)>>>>>>>>|<hidden|<block|<tformat|<cwith|1|1|3|3|cell-halign|l>|<cwith|1|1|1|3|color|white>|<cwith|1|1|1|3|cell-lsep|1.5spc>|<cwith|1|1|1|3|cell-rsep|1.5spc>|<cwith|1|1|1|3|cell-background|#A04000>|<cwith|2|-1|1|-1|cell-lsep|1.5spc>|<cwith|2|-1|1|-1|cell-rsep|1.5spc>|<cwith|1|-1|1|-1|cell-bsep|1spc>|<cwith|1|-1|1|-1|cell-tsep|1spc>|<cwith|2|8|3|3|cell-lsep|1.5spc>|<cwith|2|8|3|3|cell-rsep|1.5spc>|<cwith|2|8|3|3|cell-bsep|1spc>|<cwith|2|8|3|3|cell-tsep|1spc>|<cwith|7|7|1|3|cell-lsep|1.5spc>|<cwith|7|7|1|3|cell-rsep|1.5spc>|<cwith|7|7|1|3|cell-bsep|1spc>|<cwith|7|7|1|3|cell-tsep|1spc>|<cwith|7|7|3|3|cell-lsep|1.5spc>|<cwith|7|7|3|3|cell-rsep|1.5spc>|<cwith|7|7|3|3|cell-bsep|1spc>|<cwith|7|7|3|3|cell-tsep|1spc>|<table|<row|<cell|Operation>|<cell|Over
    <math|<with|color|white|\<bbb-Z\>>> or
    <math|<with|color|white|\<bbb-C\>>>>|<cell|Over
    <math|<with|color|white|\<bbb-K\><around*|[|x|]>>> or
    <math|<with|color|white|\<bbb-K\><around*|[|<around*|[|z|]>|]>>>>>|<row|<cell|Quotient
    + remainder>|<cell|<math|\<sim\>2*<math-ss|I><around*|(|n|)>>>|<cell|<math|\<sim\>2*<math-ss|M><around*|(|d|)>>>>|<row|<cell|Reciprocal>|<cell|<math|\<sim\><frac*|13|9>*<math-ss|I><around*|(|n|)>><space|3.5em>>|<cell|<math|\<sim\><frac*|13|9>*<math-ss|M><around*|(|d|)>>>>|<row|<cell|Square
    root>|<cell|<math|\<sim\><frac*|4|3>*<math-ss|I><around*|(|n|)>>>|<cell|<math|\<sim\><frac*|4|3>*<math-ss|M><around*|(|d|)>>>>|<row|<cell|Gcd,
    lcm>|<cell|<math|O<around*|(|<math-ss|I><around*|(|n|)>*log
    n|)>>>|<cell|<math|O<around*|(|<math-ss|M><around*|(|d|)>*log
    d|)>>>>|<row|<cell|CRT>|<cell|<math|O<around*|(|<math-ss|I><around*|(|n|)>*log
    n|)>>>|<cell|<math|O<around*|(|<math-ss|M><around*|(|d|)>*log
    d|)>>>>|<row|<cell|<stack|<tformat|<cwith|1|-1|1|1|cell-halign|l>|<table|<row|<cell|Amortized
    CRT>>|<row|<cell|Base conversion>>>>>>|<cell|<math|O<around*|(|<math-ss|I><around*|(|n|)>*<frac|log
    n|log log n>|)>>>|<cell|<math|O<around*|(|<math-ss|M><around*|(|d|)>*<frac|log
    d|log log d>|)>>>>>>>>|<hidden|<block|<tformat|<cwith|1|1|3|3|cell-halign|l>|<cwith|1|1|1|3|color|white>|<cwith|1|1|1|3|cell-lsep|1.5spc>|<cwith|1|1|1|3|cell-rsep|1.5spc>|<cwith|1|1|1|3|cell-background|#A04000>|<cwith|2|-1|1|-1|cell-lsep|1.5spc>|<cwith|2|-1|1|-1|cell-rsep|1.5spc>|<cwith|1|-1|1|-1|cell-bsep|1spc>|<cwith|1|-1|1|-1|cell-tsep|1spc>|<cwith|2|9|3|3|cell-lsep|1.5spc>|<cwith|2|9|3|3|cell-rsep|1.5spc>|<cwith|2|9|3|3|cell-bsep|1spc>|<cwith|2|9|3|3|cell-tsep|1spc>|<cwith|7|7|1|3|cell-lsep|1.5spc>|<cwith|7|7|1|3|cell-rsep|1.5spc>|<cwith|7|7|1|3|cell-bsep|1spc>|<cwith|7|7|1|3|cell-tsep|1spc>|<cwith|7|7|3|3|cell-lsep|1.5spc>|<cwith|7|7|3|3|cell-rsep|1.5spc>|<cwith|7|7|3|3|cell-bsep|1spc>|<cwith|7|7|3|3|cell-tsep|1spc>|<table|<row|<cell|Operation>|<cell|Over
    <math|<with|color|white|\<bbb-Z\>>> or
    <math|<with|color|white|\<bbb-C\>>>>|<cell|Over
    <math|<with|color|white|\<bbb-K\><around*|[|x|]>>> or
    <math|<with|color|white|\<bbb-K\><around*|[|<around*|[|z|]>|]>>>>>|<row|<cell|Quotient
    + remainder>|<cell|<math|\<sim\>2*<math-ss|I><around*|(|n|)>>>|<cell|<math|\<sim\>2*<math-ss|M><around*|(|d|)>>>>|<row|<cell|Reciprocal>|<cell|<math|\<sim\><frac*|13|9>*<math-ss|I><around*|(|n|)>><space|3.5em>>|<cell|<math|\<sim\><frac*|13|9>*<math-ss|M><around*|(|d|)>>>>|<row|<cell|Square
    root>|<cell|<math|\<sim\><frac*|4|3>*<math-ss|I><around*|(|n|)>>>|<cell|<math|\<sim\><frac*|4|3>*<math-ss|M><around*|(|d|)>>>>|<row|<cell|Gcd,
    lcm>|<cell|<math|O<around*|(|<math-ss|I><around*|(|n|)>*log
    n|)>>>|<cell|<math|O<around*|(|<math-ss|M><around*|(|d|)>*log
    d|)>>>>|<row|<cell|CRT>|<cell|<math|O<around*|(|<math-ss|I><around*|(|n|)>*log
    n|)>>>|<cell|<math|O<around*|(|<math-ss|M><around*|(|d|)>*log
    d|)>>>>|<row|<cell|<stack|<tformat|<cwith|1|-1|1|1|cell-halign|l>|<table|<row|<cell|Amortized
    CRT>>|<row|<cell|Base conversion>>>>>>|<cell|<math|O<around*|(|<math-ss|I><around*|(|n|)>*<frac|log
    n|log log n>|)>>>|<cell|<math|O<around*|(|<math-ss|M><around*|(|d|)>*<frac|log
    d|log log d>|)>>>>|<row|<cell|<stack|<tformat|<cwith|1|-1|1|1|cell-halign|l>|<table|<row|<cell|Exponential>>|<row|<cell|Logarithm>>>>>>|<cell|<math|O<around*|(|<math-ss|I><around*|(|n|)>*log
    n|)>>>|<cell|<math|O<around*|(|<math-ss|M><around*|(|d|)>|)>>>>|<row|<cell|<stack|<tformat|<cwith|1|-1|1|1|cell-halign|l>|<table|<row|<cell|Evaluation
    of>>|<row|<cell|holonomic functions>>>>>>|<cell|<math|O<around*|(|<math-ss|I><around*|(|n|)>*log<rsup|2>
    n|)>>>|<cell|<math|O<around*|(|<math-ss|M><around*|(|d|)>|)>>>>>>>>><htab|5mm>
  </hidden>|<\hidden>
    <tit|Polynomial system solving>

    <unroll|<\shown>
      <\equation*>
        <choice|<tformat|<cwith|2|2|1|1|cell-halign|c>|<cwith|2|2|6|6|cell-halign|c>|<table|<row|<cell|f<rsub|1><around*|(|x<rsub|1>,\<ldots\>,x<rsub|n>|)>>|<cell|=>|<cell|0>|<cell|<space|2em>>|<cell|deg
        f<rsub|1>>|<cell|=>|<cell|d>|<cell|<space|2em>>|<cell|>>|<row|<cell|\<vdots\>>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|\<vdots\>>|<cell|>|<cell|>|<cell|f<rsub|1>,\<ldots\>,f<rsub|n>\<in\>\<bbb-K\><around*|[|x<rsub|1>,\<ldots\>,x<rsub|n>|]>>>|<row|<cell|f<rsub|n><around*|(|x<rsub|1>,\<ldots\>,x<rsub|n>|)>>|<cell|=>|<cell|0>|<cell|>|<cell|deg
        f<rsub|n>>|<cell|=>|<cell|d>|<cell|>|<cell|>>>>>
      </equation*>
    </shown>|<\hidden*>
      <\compressed>
        <\itemize>
          <item>Generically <math|D\<assign\>d<rsup|n>> solutions in
          <math|<wide|\<bbb-K\>|\<bar\>><rsup|n>> (Bzout)

          <item>Each <math|P<rsub|i>> has at most <math|<binom|n+d|n>> terms

          <item>For fixed <math|n>, note that
          <math|<binom|n+d|n>\<sim\><frac|1|n!>*D\<asymp\>D><vspace|1fn>
        </itemize>
      </compressed>
    </hidden*>|<\hidden*>
      <\compressed>
        <strong|Main approaches>

        <\enumerate>
          <item>Groebner bases

          <item>Numeric homotopies

          <item>Geometric resolution

          <item>Triangular systems
        </enumerate>
      </compressed>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Multi-point evaluation>

    <unroll|<\shown>
      <\compact>
        For some algebra <math|\<bbb-A\>\<supseteq\>\<bbb-K\>>

        <\equation*>
          <tabular*|<tformat|<table|<row|<cell|<choice|<tformat|<table|<row|<cell|<with|math-display|true|P\<in\>\<bbb-K\><around*|[|\<b-x\>|]>=\<bbb-K\><around*|[|x<rsub|1>,\<ldots\>,x<rsub|n>|]>>>>|<row|<cell|<with|math-display|true|<around*|(|\<b-x\><rsub|1>,\<ldots\>,\<b-x\><rsub|N>|)>\<in\><around*|(|\<bbb-A\><rsup|n>|)><rsup|N>>>>>>>>|<cell|<with|color|dark
          red|<long-arrow|\<rubber-mapsto\>|<space|3em>>>>|<cell|<around*|(|P<around*|(|\<b-x\><rsub|1>|)>,\<ldots\>,P<around*|(|\<b-x\><rsub|N>|)>|)>\<in\>\<bbb-A\><rsup|N>>>>>>
        </equation*>
      </compact>
    </shown>|<\hidden*>
      <switch|<\shown>
        Checking solutions:<space|1em><math|P=f<rsub|1>,\<ldots\>,f<rsub|n>>,<space|1em><math|N=D>
      </shown>|<\hidden>
        <unroll|<\shown>
          <\compressed>
            <strong|Univariate case.> <math|n=1>, <math|N=d=deg P>,
            <math|\<bbb-A\>=\<bbb-K\>>

            <\wide-tabular>
              <tformat|<table|<row|<\cell>
                <space|7em>
              </cell>|<\cell>
                <math|O<around*|(|<math-ss|M><around*|(|d|)>*log
                d|)>><space|1.5em>
              </cell>|<\cell>
                Remainder trees<space|10.2em>
              </cell>>>>
            </wide-tabular>
          </compressed>
        </shown>|<\hidden*>
          <\compressed>
            <vspace*|0.5fn><strong|Multivariate case.>
            <math|N=<around*|(|d+1|)><rsup|n>>, <math|d=deg P>,
            <math|\<bbb-A\>=\<bbb-K\>>

            <\overlays-greyed|1|4>
              <\wide-tabular>
                <tformat|<table|<row|<\cell>
                  General
                </cell>|<\cell>
                  <math|O<around*|(|N<rsup|2>|)>>
                </cell>|<\cell>
                  Naive
                </cell>>|<row|<\cell>
                  \;
                </cell>|<\cell>
                  <overlay-from|2|<math|O<around*|(|N<rsup|\<varpi\>>|)>>|>
                </cell>|<\cell>
                  <overlay-from|2|Baby-step-giant-step<htab|5mm><math|<around*|(|<frac|3|2>\<less\>\<varpi\>\<leqslant\><frac|\<omega\>+1|2>\<leqslant\>2|)>>|>
                </cell>>|<row|<\cell>
                  <overlay-from|3|<math|\<bbb-K\>\<in\><around*|{|\<bbb-F\><rsub|q>,\<bbb-Z\>,\<bbb-Q\>|}>>|>
                </cell>|<\cell>
                  <overlay-from|3|<math|N<rsup|1+o<around*|(|1|)>>>|>
                </cell>|<\cell>
                  <overlay-from|3|Kedlaya\UUmans|>
                </cell>>|<row|<\cell>
                  <overlay-from|4|Amortized, <math|n> fixed|>
                </cell>|<\cell>
                  <overlay-from|4|<math|O<around*|(|<math-ss|M><around*|(|N|)>*<around*|(|log
                  N|)><rsup|n+2>|)>>|>
                </cell>|<\cell>
                  <overlay-from|4|Heterogeneous Grbner bases|>
                </cell>>>>
              </wide-tabular>
            </overlays-greyed>
          </compressed>
        </hidden*>|<\hidden*>
          <with|color|dark red|Kedlaya\UUmans <math|\<Longrightarrow\>> no
          theoretical obstacle to quasi-optimal polynomial system solving>
        </hidden*>>
      </hidden>>
    </hidden*>>

    \;
  </hidden>|<\hidden>
    <tit|Grbner bases>

    <unroll|<\shown>
      <\compressed>
        <strong|Generic systems>

        <\overlays-greyed|1|3>
          <\wide-tabular>
            <tformat|<cwith|1|-1|4|4|cell-hpart|1>|<cwith|1|1|3|3|cell-bsep|1spc>|<table|<row|<\cell>
              Macaulay matrices
            </cell>|<\cell>
              \;
            </cell>|<\cell>
              <math|O<around*|(|n*\<delta\>*<binom|n+\<delta\>|\<delta\>><rsup|\<omega\>>|)>>
            </cell>|<\cell>
              \;
            </cell>>|<row|<\cell>
              <overlay-from|2|Fixed dimension <math|n>|>
            </cell>|<\cell>
              \;
            </cell>|<\cell>
              <overlay-from|2|<math|D<rsup|\<omega\>+O<around*|(|1/n|)>>><math|>|>
            </cell>|<\cell>
              \;
            </cell>>|<row|<\cell>
              <overlay-from|3|F5|>
            </cell>|<\cell>
              \;
            </cell>|<\cell>
              <overlay-from|3|<math|D<rsup|3+o<around*|(|1|)>>>|>
            </cell>|<\cell>
              \;
            </cell>>>>
          </wide-tabular>
        </overlays-greyed>
      </compressed>
    </shown>|<\hidden*>
      <strong|<with|color|dark red|Is polynomial system solving essentially a
      linear algebra problem?>>
    </hidden*>|<\hidden*>
      <\compressed>
        <vspace*|1fn><strong|Reduction in softly optimal time>

        <\equation*>
          P=Q<rsub|1>*G<rsub|1>+\<cdots\>+Q<rsub|\<ell\>>*G<rsub|\<ell\>>+R
        </equation*>
      </compressed>
    </hidden*>|<\hidden*>
      <\compressed>
        <vspace*|1fn><strong|Generic bivariate systems>

        <\overlays-greyed|1|2>
          <\wide-tabular>
            <tformat|<cwith|1|-1|5|5|cell-hpart|1>|<table|<row|<\cell>
              <with|color|dark red|<em|Concise>> grev-lex Grbner basis
            </cell>|<\cell>
              <space|1em>
            </cell>|<\cell>
              <samp|M><math|<around*|(|D|)>*<around*|(|log
              D|)><rsup|1+o<around*|(|1|)>>>
            </cell>|<\cell>
              <space|1em>
            </cell>|<\cell>
              Works in practice!
            </cell>>|<row|<\cell>
              <overlay-from|2|Resultant, <math|\<bbb-K\>\<in\><around*|{|\<bbb-F\><rsub|q>,\<bbb-Z\>,\<bbb-Q\>|}>>|>
            </cell>|<\cell>
              \;
            </cell>|<\cell>
              <overlay-from|2|<math|D<rsup|1+o<around*|(|1|)>>><math|>|>
            </cell>|<\cell>
              \;
            </cell>|<\cell>
              <overlay-from|2|Uses Kedlaya\UUmans|>
            </cell>>>>
          </wide-tabular>
        </overlays-greyed>
      </compressed>
    </hidden*>>

    \;
  </hidden>|<\hidden>
    <tit|Numeric homotopies>

    <unroll|<\shown>
      <switch|<\shown>
        <\equation*>
          <choice|<tformat|<cwith|2|2|1|1|cell-halign|c>|<table|<row|<cell|f<rsub|1><around*|(|x<rsub|1>,\<ldots\>,x<rsub|n>|)>>|<cell|=>|<cell|0>>|<row|<cell|\<vdots\>>|<cell|>|<cell|>>|<row|<cell|f<rsub|n><around*|(|x<rsub|1>,\<ldots\>,x<rsub|n>|)>>|<cell|=>|<cell|0>>>>>
        </equation*>
      </shown>|<\hidden>
        <\equation*>
          <choice|<tformat|<cwith|2|2|1|1|cell-halign|c>|<table|<row|<cell|f<rsub|1><around*|(|x<rsub|1>,\<ldots\>,x<rsub|n>|)>>|<cell|=>|<cell|0>>|<row|<cell|\<vdots\>>|<cell|>|<cell|>>|<row|<cell|f<rsub|n><around*|(|x<rsub|1>,\<ldots\>,x<rsub|n>|)>>|<cell|=>|<cell|0>>>>>\<join\><choice|<tformat|<cwith|2|2|1|1|cell-halign|c>|<table|<row|<cell|<smash|x<rsub|1><rsup|d>-c<rsub|1>>>|<cell|=>|<cell|0>>|<row|<cell|\<vdots\>>|<cell|>|<cell|>>|<row|<cell|<smash|x<rsub|n><rsup|d>-c<rsub|n>>>|<cell|=>|<cell|0>>>>>
        </equation*>
      </hidden>|<\hidden>
        <\equation*>
          <choice|<tformat|<cwith|2|2|1|1|cell-halign|c>|<table|<row|<cell|f<rsub|1><around*|(|x<rsub|1>,\<ldots\>,x<rsub|n>|)>>|<cell|=>|<cell|0>>|<row|<cell|\<vdots\>>|<cell|>|<cell|>>|<row|<cell|f<rsub|n><around*|(|x<rsub|1>,\<ldots\>,x<rsub|n>|)>>|<cell|=>|<cell|0>>>>>\<join\><choice|<tformat|<cwith|2|2|1|1|cell-halign|c>|<table|<row|<cell|<smash|x<rsub|1><rsup|d>-c<rsub|1>>>|<cell|=>|<cell|0>>|<row|<cell|\<vdots\>>|<cell|>|<cell|>>|<row|<cell|<smash|x<rsub|n><rsup|d>-c<rsub|n>>>|<cell|=>|<cell|0>>>>>\<longrightarrow\><choice|<tformat|<cwith|2|2|1|1|cell-halign|c>|<table|<row|<cell|<around*|(|1-t|)>*f<rsub|1><around*|(|x<rsub|1>,\<ldots\>,x<rsub|n>|)>+t*<around*|(|<smash|x<rsub|1><rsup|d>-c<rsub|1>>|)>>|<cell|=>|<cell|0>>|<row|<cell|\<vdots\>>|<cell|>|<cell|>>|<row|<cell|<around*|(|1-t|)>*f<rsub|n><around*|(|x<rsub|1>,\<ldots\>,x<rsub|n>|)>+t*<around*|(|<smash|x<rsub|n><rsup|d>-c<rsub|n>>|)>>|<cell|=>|<cell|0>>>>>
        </equation*>
      </hidden>>
    </shown>|<\hidden*>
      <\compressed>
        <strong|How many homotopy steps do we need?>

        <\overlays-greyed|1|4>
          <\wide-tabular>
            <tformat|<cwith|1|1|3|3|cell-bsep|1spc>|<table|<row|<\cell>
              Theoretical average expected bound
            </cell>|<\cell>
              <math|O<around*|(|d<rsup|3/2>*n*N<rsup|1/2>|)>>
            </cell>|<\cell>
              <math|N\<assign\>n*<binom|n+d|d><overlay-from|2|\<sim\><frac|1|<around*|(|n-1|)>!>*D|>>
            </cell>>|<row|<\cell>
              <overlay-from|3|In practice|>
            </cell>|<\cell>
              <overlay-from|3|<math|O<around*|(|log D|)>>|>
            </cell>|<\cell>
              <overlay-from|4|<math|100*<sqrt|n>><space|0.6spc>?|>
            </cell>>>>
          </wide-tabular>
        </overlays-greyed>
      </compressed>
    </hidden*>|<\hidden*>
      <switch|<\shown>
        <\compressed>
          <vspace*|0.75fn><strong|Total cost<phantom|, sparse case>>

          <\wide-tabular>
            <tformat|<cwith|1|1|3|3|cell-bsep|1spc>|<table|<row|<\cell>
              In theory, worst case
            </cell>|<\cell>
              <math|O<around*|(|d<rsup|3/2>*n*N<rsup|3/2>*D|)>>
            </cell>|<\cell>
              <math|D<rsup|5/2+o<around*|(|1|)>>>
            </cell>>|<row|<\cell>
              In practice
            </cell>|<\cell>
              <math|O<around*|(|N*D*log D|)>>
            </cell>|<\cell>
              <math|D<rsup|2+o<around*|(|1|)>>>
            </cell>>>>
          </wide-tabular>
        </compressed>
      </shown>|<\hidden>
        <\compressed>
          <vspace*|0.75fn><strong|Total cost, sparse case>

          <\wide-tabular>
            <tformat|<cwith|1|1|3|3|cell-bsep|1spc>|<table|<row|<\cell>
              In theory, worst case
            </cell>|<\cell>
              <math|O<around*|(|d<rsup|3/2>*n*N<rsup|1/2>*D|)>>
            </cell>|<\cell>
              <math|D<rsup|3/2+o<around*|(|1|)>>>
            </cell>>|<row|<\cell>
              In practice
            </cell>|<\cell>
              <math|O<around*|(|<greyed|N*>D*log D|)>>
            </cell>|<\cell>
              <math|D<rsup|1+o<around*|(|1|)>>>
            </cell>>>>
          </wide-tabular>
        </compressed>
      </hidden>|<\hidden>
        <\compressed>
          <vspace*|0.75fn><strong|Total cost<phantom|, sparse case>>

          <\wide-tabular>
            <tformat|<cwith|1|1|3|3|cell-bsep|1spc>|<table|<row|<\cell>
              In theory, worst case
            </cell>|<\cell>
              <math|O<around*|(|d<rsup|3/2>*n*N<rsup|3/2>*D|)>>
            </cell>|<\cell>
              <math|D<rsup|5/2+o<around*|(|1|)>>>
            </cell>>|<row|<\cell>
              In practice
            </cell>|<\cell>
              <math|O<around*|(|N*D*log D|)>>
            </cell>|<\cell>
              <math|D<rsup|2+o<around*|(|1|)>>>
            </cell>>>>
          </wide-tabular>
        </compressed>
      </hidden>>
    </hidden*>|<\hidden*>
      Softly optimal <math|b>-bit multivariate multi-point evaluation
      <math|<long-arrow|\<rubber-rightarrow\>|would>>
      <hgroup|<math|<wide|O|~><around*|(|<around*|(|D+<math-ss|I><around*|(|b|)>|)>*D|)>>>
    </hidden*>>

    \;
  </hidden>|<\hidden>
    <tit|Geometric resolution>

    <unroll|<\shown>
      <\equation*>
        <choice|<tformat|<cwith|2|2|1|1|cell-halign|c>|<table|<row|<cell|f<rsub|1><around*|(|x<rsub|1>,\<ldots\>,x<rsub|n>|)>>|<cell|=>|<cell|0>>|<row|<cell|\<vdots\>>|<cell|>|<cell|>>|<row|<cell|f<rsub|n><around*|(|x<rsub|1>,\<ldots\>,x<rsub|n>|)>>|<cell|=>|<cell|0>>>>>\<nocomma\><space|4em><choice|<tformat|<cwith|2|2|1|1|cell-halign|c>|<table|<row|<cell|x<rsub|1>>|<cell|=>|<cell|U<rsub|1><around*|(|t|)>\<in\>\<bbb-A\>>>|<row|<cell|\<vdots\>>|<cell|>|<cell|>>|<row|<cell|x<rsub|n>>|<cell|=>|<cell|U<rsub|n><around*|(|t|)>\<in\>\<bbb-A\>>>>>>\<nocomma\><space|2em><tabular|<tformat|<table|<row|<cell|\<bbb-A\>=\<bbb-K\><around*|[|t|]>/<around*|(|q<around*|(|t|)>|)>>>|<row|<cell|deg
        q=D>>>>>
      </equation*>
    </shown>|<\hidden*>
      <switch|<\shown>
        <vspace*|1fn><strong|Incremental approach>

        <switch|<\shown>
          <\equation*>
            <choice|<tformat|<table|<row|<cell|f<rsub|1><around*|(|x<rsub|1>,0,\<ldots\>,0|)>>|<cell|=>|<cell|0>>>>>
          </equation*>
        </shown>|<\hidden>
          <\equation*>
            <choice|<tformat|<table|<row|<cell|f<rsub|1><around*|(|x<rsub|1>,x<rsub|2>,0,\<ldots\>,0|)>>|<cell|=>|<cell|0>>|<row|<cell|f<rsub|2><around*|(|x<rsub|1>,x<rsub|2>,0,\<ldots\>,0|)>>|<cell|=>|<cell|0>>>>>
          </equation*>
        </hidden>|<\hidden>
          <\equation*>
            <choice|<tformat|<table|<row|<cell|f<rsub|1><around*|(|x<rsub|1>,x<rsub|2>,x<rsub|3>,0,\<ldots\>,0|)>>|<cell|=>|<cell|0>>|<row|<cell|f<rsub|2><around*|(|x<rsub|1>,x<rsub|2>,x<rsub|3>,0,\<ldots\>,0|)>>|<cell|=>|<cell|0>>|<row|<cell|f<rsub|3><around*|(|x<rsub|1>,x<rsub|2>,x<rsub|3>,0,\<ldots\>,0|)>>|<cell|=>|<cell|0>>>>>
          </equation*>
        </hidden>|<\hidden>
          <\equation*>
            <choice|<tformat|<cwith|2|2|1|1|cell-halign|c>|<table|<row|<cell|f<rsub|1><around*|(|x<rsub|1>,\<ldots\>,x<rsub|n>|)>>|<cell|=>|<cell|0>>|<row|<cell|\<vdots\>>|<cell|>|<cell|>>|<row|<cell|f<rsub|n><around*|(|x<rsub|1>,\<ldots\>,x<rsub|n>|)>>|<cell|=>|<cell|0>>>>>
          </equation*>
        </hidden>>
      </shown>|<\hidden>
        <vspace*|1fn><strong|Complexity bounds>

        <\overlays-greyed|1|5>
          <\wide-tabular>
            <tformat|<cwith|1|-1|1|-1|cell-bsep|0.5spc>|<cwith|1|-1|1|-1|cell-tsep|0.5spc>|<table|<row|<\cell>
              Sparse
            </cell>|<\cell>
              <math|L*<wide|O|~><around*|(|D<rsup|2>|)>>
            </cell>|<\cell>
              <math|L> sparse size of <math|f<rsub|1>,\<ldots\>,f<rsub|n>>
            </cell>>|<row|<\cell>
              <overlay-from|2|Dense|>
            </cell>|<\cell>
              <overlay-from|2|<math|D<rsup|2+o<around*|(|1|)>>>|>
            </cell>|<\cell>
              <overlay-from|2|<math|L=n*<binom|n+d|d>=D<rsup|o<around*|(|1|)>>>
              for <math|n\<gg\>d>|>
            </cell>>|<row|<\cell>
              \;
            </cell>|<\cell>
              <overlay-from|3|<math|<wide|O|~><around*|(|D<rsup|3>|)>>|>
            </cell>|<\cell>
              <overlay-from|3|<math|L=O<around*|(|D|)>> for <math|n\<ll\>d>|>
            </cell>>|<row|<\cell>
              <overlay-from|4|<math|\<bbb-K\>\<in\><around*|{|\<bbb-F\><rsub|q>,\<bbb-Z\>,\<bbb-Q\>|}>>|>
            </cell>|<\cell>
              <overlay-from|4|<math|D<rsup|2+o<around*|(|1|)>>>|>
            </cell>|<\cell>
              <overlay-from|4|using Kedlaya\UUmans|>
            </cell>>|<row|<\cell>
              <overlay-from|5|<math|\<bbb-K\>\<in\><around*|{|\<bbb-Z\>,\<bbb-Q\>|}>>|>
            </cell>|<\cell>
              <overlay-from|5|<math|<around*|(|D+<math-ss|I><around*|(|b|)>|)>*D<rsup|1+o<around*|(|1|)>>>|>
            </cell>|<\cell>
              <overlay-from|5|bit precision <math|b\<succcurlyeq\>D> for
              generic systems|>
            </cell>>>>
          </wide-tabular>
        </overlays-greyed>
      </hidden>>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Modular composition>

    \;

    <\compressed>
      <math|n=N=1>, <math|\<bbb-A\>=\<bbb-K\><around*|[|\<alpha\>|]>/<around*|(|\<mu\><around*|(|\<alpha\>|)>|)>>
      for irreducible <math|\<mu\>> of degree <math|d>

      Given <math|P\<in\>\<bbb-K\><around*|[|x|]>> of degree <math|d> and
      <math|u\<in\>\<bbb-A\>>, compute <math|P<around*|(|u|)>\<in\>\<bbb-A\>>
    </compressed>

    \;

    <\overlays-greyed|1|4>
      <\wide-tabular>
        <tformat|<table|<row|<\cell>
          General
        </cell>|<\cell>
          \;
        </cell>|<\cell>
          <math|O<around*|(|d<rsup|2>|)>>
        </cell>|<\cell>
          \;
        </cell>|<\cell>
          naive
        </cell>>|<row|<\cell>
          \;
        </cell>|<\cell>
          \;
        </cell>|<\cell>
          <math|O<around*|(|d<rsup|\<varpi\>>+<sqrt|d>*<math-ss|M><around*|(|d|)>|)>>
        </cell>|<\cell>
          \;
        </cell>|<\cell>
          baby-step-giant-step
        </cell>>|<row|<\cell>
          <overlay-from|2|<math|\<bbb-K\>\<in\><around*|{|\<bbb-F\><rsub|q>,\<bbb-Z\>,\<bbb-Q\>|}>>|>
        </cell>|<\cell>
          \;
        </cell>|<\cell>
          <overlay-from|2|<math|d*\<mathe\><rsup|<with|math-level|2|O<around*|(|<sqrt|log
          d*log log d>|)>>>>|>
        </cell>|<\cell>
          \;
        </cell>|<\cell>
          <overlay-from|2|Kedlaya\UUmans|>
        </cell>>|<row|<\cell>
          <overlay-from|3|<math|\<bbb-K\>=\<bbb-C\>>, large precision|>
        </cell>|<\cell>
          \;
        </cell>|<\cell>
          <overlay-from|3|<math|O<around*|(|<math-ss|M><around*|(|d|)>*log
          d|)>>|>
        </cell>|<\cell>
          \;
        </cell>|<\cell>
          \;
        </cell>>|<row|<\cell>
          <overlay-from|4|<math|\<bbb-K\>=\<bbb-F\><rsub|p>>, smooth
          <math|d>, probabilistic|>
        </cell>|<\cell>
          \;
        </cell>|<\cell>
          <overlay-from|4|<math|<wide|O|~><around*|(|d|)>>|>
        </cell>|<\cell>
          \;
        </cell>|<\cell>
          \;
        </cell>>>>
      </wide-tabular>
    </overlays-greyed>
  </hidden>|<\hidden>
    <tit|Univariate factorization>

    \;

    <\overlays-greyed|1|7>
      <\wide-tabular>
        <tformat|<cwith|1|-1|1|-1|cell-bsep|0.75spc>|<cwith|1|-1|1|-1|cell-tsep|0.75spc>|<cwith|3|3|1|-1|cell-bsep|3spc>|<table|<row|<\cell>
          <math|\<bbb-K\>=\<bbb-C\>>
        </cell>|<\cell>
          <math|O<around*|(|<math-ss|I><around*|(|b*d|)>*log d|)>>
        </cell>|<\cell>
          separable, high bit precision <math|b>
        </cell>>|<row|<\cell>
          \;
        </cell>|<\cell>
          <overlay-from|2|<math|O<around*|(|<math-ss|I><around*|(|b|)>*d*log<rsup|2>
          d*<around*|(|log<rsup|2> d+log b|)>|)>>|>
        </cell>|<\cell>
          <overlay-from|2|<math|b\<geqslant\>d*log d>, approximate|>
        </cell>>|<row|<\cell>
          \;
        </cell>|<\cell>
          <overlay-from|3|<math|<wide|O|~><around*|(|d*<around*|(|b+log
          \<kappa\>|)>|)>>|>
        </cell>|<\cell>
          <overlay-from|3|<math|\<kappa\>>: suitable condition number|>
        </cell>>|<row|<\cell>
          <overlay-from|4|<math|\<bbb-K\>=\<bbb-F\><rsub|q>=\<bbb-F\><rsub|p<rsup|\<kappa\>>>>|>
        </cell>|<\cell>
          <overlay-from|4|<math|O<around*|(|<math-ss|M><rsub|q><around*|(|d|)>*log
          q*log d|)>>|>
        </cell>|<\cell>
          <overlay-from|4|Cantor\UZassenhaus|>
        </cell>>|<row|<\cell>
          \;
        </cell>|<\cell>
          <overlay-from|5|<math|O<around*|(|<math-ss|M><rsub|q><around*|(|d|)>*log
          d|)>>|>
        </cell>|<\cell>
          <overlay-from|5|tangent Graeffe, <math|q-1> smooth, splits|>
        </cell>>|<row|<\cell>
          \;
        </cell>|<\cell>
          <overlay-from|6|<math|<around*|(|d<rsup|0.5+o<around*|(|1|)>>+\<kappa\><rsup|o<around*|(|1|)>>+log
          p|)>*<wide|O|~><around*|(|d*log q|)>>|>
        </cell>|<\cell>
          <overlay-from|6|using Kedlaya\UUmans|>
        </cell>>|<row|<\cell>
          \;
        </cell>|<\cell>
          <overlay-from|7|<math|<wide|O|~><around*|(|d*log q|)>>|>
        </cell>|<\cell>
          <overlay-from|7|<math|\<kappa\>> smooth, <math|d> small|>
        </cell>>>>
      </wide-tabular>
    </overlays-greyed>
  </hidden>|<\hidden>
    <tit|Conclusion>

    \;

    <strong|Can a complexity-driven approach help us to solve polynomial
    systems faster?>

    <\itemize>
      <item>What is the complexity of multivariate multi-point evaluation?

      <item>How can we take advantage of fast polynomial arithmetic?

      <item>How does bit complexity rhyme with condition numbers and clusters
      of solutions?
    </itemize>
  </hidden>|<hidden|<\with-screen-color|<pattern|vertical-white-black.png|100%|100%|<eff-gradient|0|#400A00|white>>>
    <\center>
      <\with|par-par-sep|0.3333fn>
        <\center>
          <really-huge|<strong|<with|color|dark red|Thank you
          !<rsup|<rsup|>>>>>
        </center>
      </with>

      <tabular|<tformat|<cwith|1|3|1|1|cell-halign|c>|<cwith|1|1|1|1|cell-hyphen|t>|<cwith|1|1|1|1|cell-tsep|0.5em>|<table|<row|<\cell>
        <with|shadow-dx|0ln|shadow-dy|0ln|shadow-color|white|shadow-blur-radius|0.25ln|<shadow|<image|Download-TeXmacs.png|0.58par|||>>>
      </cell>>|<row|<cell|<strong|><center|>>>|<row|<cell|<with|color|white|<verbatim|http://www.texmacs.org>>>>>>>
    </center>

    \;
  </with-screen-color>>>
</body>

<\initial>
  <\collection>
    <associate|eqn-long-above|<macro|0fn>>
    <associate|eqn-long-below|<macro|0fn>>
    <associate|eqn-short-above|<macro|0fn>>
    <associate|eqn-short-below|<macro|0fn>>
    <associate|font|greek=pagella,math=pagella,Linux Biolinum>
    <associate|font-base-size|10>
    <associate|font-family|rm>
    <associate|info-flag|none>
    <associate|locus-color|#aaf>
    <associate|magnification|1.85>
    <associate|math-font|math-pagella>
    <associate|ornament-corner|50%>
    <associate|ornament-hpadding|1.5spc>
    <associate|ornament-vpadding|1.5spc>
    <associate|page-bot|-5mm>
    <associate|page-height|auto>
    <associate|page-medium|beamer>
    <associate|page-type|8:5>
    <associate|page-width|auto>
    <associate|preamble|false>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|auto-2|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|zexptab1|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|zexptab2|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|table>
      <tuple|normal|Time in seconds to expand
      <with|color|<quote|#503050>|font-family|<quote|rm>|<with|mode|<quote|math>|\<mathe\><rsup|z*\<mathe\><rsup|<with|math-level|<quote|1>|z>>>>>
      at various orders, using rational coefficients.|<pageref|auto-1>>

      <tuple|normal|Time in seconds to expand
      <with|color|<quote|#503050>|font-family|<quote|rm>|<with|mode|<quote|math>|\<mathe\><rsup|z*\<mathe\><rsup|<with|math-level|<quote|1>|z>>>>>,
      using 10000-bit floating point coefficients.|<pageref|auto-2>>
    </associate>
  </collection>
</auxiliary>